unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, SHDocVw, StdCtrls, mshtml, Grids, shellapi, DB, dxmdaset,
  dxExEdtr, dxDBCtrl, dxDBGrid, dxTL, dxCntner, ComCtrls, Buttons, ToolWin,
  cxControls, cxSplitter, dxDBTLCl, dxGrClms, cxPC, AppEvnts, Variants,
  cxContainer, cxEdit, cxTextEdit, cxMaskEdit, cxDropDownEdit, cxCalendar;

type
  TForm1 = class(TForm)
    dxMemData1: TdxMemData;
    dxMemData1StockID: TStringField;
    dxMemData1StockName: TStringField;
    DataSource1: TDataSource;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    cxSplitter1: TcxSplitter;
    StatusBar1: TStatusBar;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    cxPageControl1: TcxPageControl;
    cxTabSheet1: TcxTabSheet;
    cxTabSheet2: TcxTabSheet;
    WebBrowser1: TWebBrowser;
    Memo1: TMemo;
    dxDBGrid1: TdxDBGrid;
    dxMemData1TransDate: TStringField;
    dxMemData2: TdxMemData;
    dxMemData2StockID: TStringField;
    dxMemData2StockIDEh: TStringField;
    dxMemData2StockName: TStringField;
    dxMemData2StockType: TStringField;
    dxMemData2StockKind: TStringField;
    dxMemData2IssueDate: TDateField;
    dxMemDataStrikePrice: TFloatField;
    dxMemData1OpeningPrice: TFloatField;
    dxMemData1CeilingPrice: TFloatField;
    dxMemData1ReservePrice: TFloatField;
    dxMemData1StrikeCound2: TFloatField;
    dxMemData1StrikeCound: TCurrencyField;
    cxDateEdit2: TcxDateEdit;
    dxMemData1ClosingPrice: TFloatField;
    dxMemData1OrderBuyB: TFloatField;
    dxMemData1OrderPriseS: TFloatField;
    dxMemData1PriceFluctuation: TStringField;
    dxMemData1PriceFluctuationPrice: TFloatField;
    dxMemData1PER: TFloatField;
    dxDBGrid1RecId: TdxDBGridColumn;
    dxDBGrid1StockID: TdxDBGridMaskColumn;
    dxDBGrid1StockName: TdxDBGridMaskColumn;
    dxDBGrid1StrikeCound: TdxDBGridCurrencyColumn;
    dxDBGrid1StrikeCound2: TdxDBGridMaskColumn;
    dxDBGrid1StrikePrice: TdxDBGridMaskColumn;
    dxDBGrid1OpeningPrice: TdxDBGridMaskColumn;
    dxDBGrid1CeilingPrice: TdxDBGridMaskColumn;
    dxDBGrid1ReservePrice: TdxDBGridMaskColumn;
    dxDBGrid1ClosingPrice: TdxDBGridMaskColumn;
    dxDBGrid1PriceFluctuation: TdxDBGridMaskColumn;
    dxDBGrid1PriceFluctuationPrice: TdxDBGridMaskColumn;
    dxDBGrid1OrderPriseB: TdxDBGridMaskColumn;
    dxDBGrid1OrderPriseS: TdxDBGridMaskColumn;
    dxDBGrid1PER: TdxDBGridMaskColumn;
    dxDBGrid1TradeDate: TdxDBGridMaskColumn;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ProgressBar1: TProgressBar;
    CheckBox1: TCheckBox;
    procedure WebBrowser1DocumentComplete(Sender: TObject; const pDisp: IDispatch; var URL: OleVariant);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure dxDBGrid1CustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IsComplete: boolean;

implementation

{$R *.DFM}

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject; const pDisp: IDispatch; var URL: OleVariant);
begin
  IsComplete := True;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  slTemp: TStringList;
  I: integer;
  HTMLDoc: IHTMLDocument2;
  sStr, sStockID: string;
  function GetNumeric(SS: string): Double;
    function ReplaceString(var S: string; const Token, NewToken: string; bCaseSensitive: Boolean): Boolean;
    var
      I: Integer;
      sFirstPart: string;
    begin
      if bCaseSensitive then
        I := AnsiPos(Token, S)
      else
        I := AnsiPos(AnsiUpperCase(Token), AnsiUpperCase(S));

      if I <> 0 then
      begin
        sFirstPart := Copy(S, 1, I - 1) + NewToken; // קKLaj
        S := Copy(S, I + Length(Token), Maxint);
      end;

      Result := I <> 0;
      if Result then
      begin
        ReplaceString(S, Token, NewToken, bCaseSensitive);
        S := sFirstPart + S;
      end;
    end;
  begin
    ss := Trim(ss);
    if ss <> '' then
    begin
      ReplaceString(ss, ',', '', false);
      result := StrToFloat(ss);
    end
    else
      result := 0;
  end;
  function GetCurrStr(sSourceStr: string): string;
  var
    iStart, iEnd: integer;
    sStr: string;
  begin
    iStart := Pos('size=2>', sSourceStr) + 7;
    iEnd := Pos('</FONT>', sSourceStr);
    result := Trim(Copy(sSourceStr, iStart, iEnd - iStart));
  end;
  function GetCurrStr2(sSourceStr: string): string;
  begin
    if Pos('', sSourceStr) > 0 then
      result := ''
    else
      if Pos('', sSourceStr) > 0 then
        result := ''
      else
        result := '';
  end;
begin
  IsComplete := False;
  if Trim(cxDateEdit2.Text) = '' then
    Exit;
  Cursor := crHourGlass;
  StatusBar1.Panels[0].Text := 'bJ...';
  webbrowser1.Navigate('http://www.tse.com.tw/t11html/A112' + FormatDateTime('yyyymmdd', cxDateEdit2.Date) + '.htm');
  while not IsComplete do
    application.ProcessMessages;
  StatusBar1.Panels[0].Text := '';
  Cursor := crDefault;
  HTMLDoc := webbrowser1.Document as IHTMLDocument2;
  slTemp := TStringList.Create;
  slTemp.Text := HTMLDoc.body.innerHTML;
  Memo1.Lines.Text := slTemp.Text;
  dxMemData1.DisableControls;
  ProgressBar1.Max := slTemp.Count;
  StatusBar1.Panels[0].Text := 'פJƤ...';
  StatusBar1.Update;
  for I := 0 to slTemp.Count - 1 do
  begin
    if Trim(slTemp[I]) = '<TR>' then
    begin
      sStockID := GetCurrStr(slTemp[I + 1]);
      if dxMemData2.Locate('StockID', sStockID, []) then
      begin
        if CheckBox1.Checked then
        begin
          if not dxMemData1.Locate('TradeDate;StockID', VarArrayOf([DateToStr(cxDateEdit2.Date), sStockID]), [loPartialKey]) then
          begin
            dxMemData1.Append;
            dxMemData1.FieldByName('TradeDate').AsString := DateToStr(cxDateEdit2.Date);
            dxMemData1.FieldByName('StockID').AsString := sStockID;
            dxMemData1.FieldByName('StockName').AsString := GetCurrStr(slTemp[I + 2]);
            dxMemData1.FieldByName('StrikeCound').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 3]));
            dxMemData1.FieldByName('StrikeCound2').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 4]));
            dxMemData1.FieldByName('StrikePrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 5]));
            dxMemData1.FieldByName('OpeningPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 6]));
            dxMemData1.FieldByName('CeilingPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 7]));
            dxMemData1.FieldByName('ReservePrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 8]));
            dxMemData1.FieldByName('ClosingPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 9]));
            dxMemData1.FieldByName('PriceFluctuation').AsString := GetCurrStr2(slTemp[I + 10]);
            dxMemData1.FieldByName('PriceFluctuationPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 11]));
            dxMemData1.FieldByName('OrderPriseB').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 12]));
            dxMemData1.FieldByName('OrderPriseS').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 13]));
            dxMemData1.FieldByName('PER').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 14]));
            dxMemData1.Post;
          end;
        end
        else
        begin
          dxMemData1.Append;
          dxMemData1.FieldByName('TradeDate').AsString := DateToStr(cxDateEdit2.Date);
          dxMemData1.FieldByName('StockID').AsString := sStockID;
          dxMemData1.FieldByName('StockName').AsString := GetCurrStr(slTemp[I + 2]);
          dxMemData1.FieldByName('StrikeCound').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 3]));
          dxMemData1.FieldByName('StrikeCound2').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 4]));
          dxMemData1.FieldByName('StrikePrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 5]));
          dxMemData1.FieldByName('OpeningPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 6]));
          dxMemData1.FieldByName('CeilingPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 7]));
          dxMemData1.FieldByName('ReservePrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 8]));
          dxMemData1.FieldByName('ClosingPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 9]));
          dxMemData1.FieldByName('PriceFluctuation').AsString := GetCurrStr2(slTemp[I + 10]);
          dxMemData1.FieldByName('PriceFluctuationPrice').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 11]));
          dxMemData1.FieldByName('OrderPriseB').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 12]));
          dxMemData1.FieldByName('OrderPriseS').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 13]));
          dxMemData1.FieldByName('PER').AsFloat := GetNumeric(GetCurrStr(slTemp[I + 14]));
          dxMemData1.Post
        end;
      end;
      ProgressBar1.Position := I;
      ProgressBar1.Update;
    end;
  end;
  StatusBar1.Panels[0].Text := '';
  ProgressBar1.Position := 0;
  dxMemData1.EnableControls;
  slTemp.Free;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  SaveDialog1.FileName := '';
  SaveDialog1.Filter := 'HTML files (*.htm)|*.htm|Excel Worksheet (*.xls)|*.xls|Text files (*.txt)|*.txt|XML files (*.xml)|*.xml';
  if SaveDialog1.Execute then
  begin
    case SaveDialog1.FilterIndex of
      1: dxDBGrid1.SaveToHTML(SaveDialog1.FileName + '.htm', True);
      2: dxDBGrid1.SaveToXLS(SaveDialog1.FileName + '.xls', True);
      3: dxDBGrid1.SaveToText(SaveDialog1.FileName + '.txt', False, chr(10), '', '');
      4: dxDBGrid1.SaveToXML(SaveDialog1.FileName + '.xml', True);
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  dxMemData1.Close;
  dxMemData1.Open;
  dxMemData2.Close;
  dxMemData2.LoadFromTextFile(ExtractFilePath(ParamStr(0)) + '\StockID');
  dxMemData2.Open;
end;

procedure TForm1.dxDBGrid1CustomDrawCell(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
  ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
  var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
  var ADone: Boolean);
var
  Value: Variant;
begin
  if not ASelected and (AColumn = dxDBGrid1PriceFluctuation) then
  begin
    Value := ANode.Values[AColumn.Index];
    if not VarIsNull(Value) then
    begin
      if Copy(Value, 1, 2) = '' then
      begin
        AFont.Color := clRed;
      end
      else
        if Copy(Value, 1, 2) = '' then
        begin
          AFont.Color := clGreen;
        end;
    end;
  end;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  dxMemData1StrikeCound.DisplayFormat := '';
  dxMemData1StrikeCound2.DisplayFormat := '';
  dxMemDataStrikePrice.DisplayFormat := '';
  dxMemData1.SaveToTextFile(ExtractFilePath(ParamStr(0)) + '\Trade');
  dxMemData1StrikeCound.DisplayFormat := '#,##0';
  dxMemData1StrikeCound2.DisplayFormat := '#,##0';
  dxMemDataStrikePrice.DisplayFormat := '#,##0';
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  dxMemData1.Close;
  dxMemData1StrikeCound.DisplayFormat := '';
  dxMemData1StrikeCound2.DisplayFormat := '';
  dxMemDataStrikePrice.DisplayFormat := '';
  if FileExists(ExtractFilePath(ParamStr(0)) + '\Trade') then
    dxMemData1.LoadFromTextFile(ExtractFilePath(ParamStr(0)) + '\Trade');
  dxMemData1.Open;
  dxMemData1StrikeCound.DisplayFormat := '#,##0';
  dxMemData1StrikeCound2.DisplayFormat := '#,##0';
  dxMemDataStrikePrice.DisplayFormat := '#,##0';
end;

end.

